--FuelGauge.
--by aarbro [aarbro@hotmail.com]


FuelGauge = {

	Editor = {
		Model="Objects/EXP/Editor/editor_speedo.cgf",
	},

	Properties = {
		VehicleName = "", --only active for a specific type or instance on the map. Empty for all.
		bEnabled = 1,
		VehicleRealism = "",

		Dial = {
			texture_Texture = "Objects/EXP/Gauges/fuel.dds", --dds/dxt1, one bit or no transparency only, no mipmaps needed.
			ColorR = 1,
			ColorG = 1,
			ColorB = 1,
			Transparency = 1,
			nBlending = 4, --4 for transparency, 0 for opaque...
			LocationX=660,
			LocationY=50,
			Width=128,
			Height=128,
		},

		Needle = {
			CenterX = 64, --rotation center of the needle, offset from top left origin of dial texture.
			CenterY = 87,
			Length = 40, --total length in pixels
			ColorR = 0.75,
			ColorG = 0,
			ColorB = 0,
			Transparency = 1,
			fAngleMin = 137, --down is 0, left 90, up 180, right 270. Increasing clockwise.
			fAngleMax = 223, --can turn left or right but never pass 0.
			fValueMin = 0,
			fValueMax = 75,
			fExp = -1,
		},

		Digits = {
			bShowDigits = 0,
			DigitFormat = "%u", --format as printf
			FontName = "default",
			FontEffect = "default",
			Width = 20,
			Height = 20,
			LocationX = 64, --top left position, offset from top left origin of dial texture.
			LocationY = 128,
			ColorR = 1,
			ColorG = 1,
			ColorB = 1,
			Transparency = 1,
			Scale = 1.0,
		},

	},
	
	dial_texture = nil,
	unit_mult = 1.0,
	last_time = 0,
	distance = 0,
	
};
-------------------------------------------------------------------------------
function FuelGauge:OnPropertyChange()
	self:OnReset();
end
-------------------------------------------------------------------------------

function FuelGauge:OnInit()
	self:OnReset();

end
-------------------------------------------------------------------------------

function FuelGauge:OnReset()


	self:EnableUpdate(0);
	
	self.dial_texture = System:LoadTexture( self.Properties.Dial.texture_Texture );
if (Hud~=nil) then
	Hud:EnableCustomHud(1); --turn on global hud updates
end
	self.last_time = System:GetCurrTime();

end

-------------------------------------------------------------------------------
function FuelGauge:OnUpdate()

end
-------------------------------------------------------------------------------
function FuelGauge:OnShutDown()
end
-------------------------------------------------------------------------------
function FuelGauge:OnSave(stm)
end
-------------------------------------------------------------------------------
function FuelGauge:OnLoad(stm)
end
-------------------------------------------------------------------------------

function FuelGauge:OnUpdateCustomHud()

	if ( self.Properties.bEnabled == 0 ) then
		return;
	end

	if ( not _localplayer.theVehicle ) then --player is not in vehicle
		return;
	end

	if ( self.Properties.VehicleName ~= _localplayer.theVehicle.classname and --wrong type of vehicle
			 self.Properties.VehicleName ~= _localplayer.theVehicle:GetName() and
			 self.Properties.VehicleName ~= "" ) then
		return;
	end

	if ( _localplayer.theVehicle.driverT.entity ~= _localplayer ) then --player is not driving
		return;
	end

	local value = self:CalcValue();
	
	if ( self.Properties.Needle.fExp ~= -1 ) then
		value = value ^ self.Properties.Needle.fExp;
	end
	
	local amin = self.Properties.Needle.fAngleMin;
	local amax = self.Properties.Needle.fAngleMax;
	local smin = self.Properties.Needle.fValueMin;
	local smax = self.Properties.Needle.fValueMax;
	
	local ang_span = amax-amin;
	local spd_span = smax-smin;
	local ang = ( ( (limit( value, smin, smax ) - smin) / spd_span) * ang_span ) + amin;
	
	ang = ( 360 - ang + 270 ) / 180 * PI; --move 0, change direction and convert to radians
	local x = cos( ang ) * self.Properties.Needle.Length;
	local y = -sin( ang ) * self.Properties.Needle.Length;
	local x0 = cos( ang + PI / 2 ) * 0.75;
	local y0 = -sin( ang + PI / 2 ) * 0.75;
	local x2 = cos( ang - PI / 2 ) * 0.75;
	local y2 = -sin( ang - PI / 2 ) * 0.75;
	
	local src_x = self.Properties.Dial.LocationX + self.Properties.Needle.CenterX;
	local src_y = self.Properties.Dial.LocationY + self.Properties.Needle.CenterY;
	local dest_x = self.Properties.Dial.LocationX + self.Properties.Needle.CenterX + x;
	local dest_y = self.Properties.Dial.LocationY + self.Properties.Needle.CenterY + y;

	
	System:DrawImageColor(
			self.dial_texture,
			self.Properties.Dial.LocationX,
			self.Properties.Dial.LocationY,
			self.Properties.Dial.Width,
			self.Properties.Dial.Height,
			self.Properties.Dial.nBlending,
			self.Properties.Dial.ColorR,
			self.Properties.Dial.ColorG,
			self.Properties.Dial.ColorB,
			self.Properties.Dial.Transparency
		);


	System:Draw2DLine(
			src_x,
			src_y,
			dest_x,
			dest_y,
			self.Properties.Needle.ColorR,
			self.Properties.Needle.ColorG,
			self.Properties.Needle.ColorB,
			self.Properties.Needle.Transparency
		);
	System:Draw2DLine(
			src_x + x0,
			src_y + y0,
			dest_x,
			dest_y,
			self.Properties.Needle.ColorR,
			self.Properties.Needle.ColorG,
			self.Properties.Needle.ColorB,
			self.Properties.Needle.Transparency
		);
	System:Draw2DLine(
			src_x + x2,
			src_y + y2,
			dest_x,
			dest_y,
			self.Properties.Needle.ColorR,
			self.Properties.Needle.ColorG,
			self.Properties.Needle.ColorB,
			self.Properties.Needle.Transparency
		);

	if ( self.Properties.Digits.bShowDigits == 1 ) then
  	Game:SetHUDFont( self.Properties.Digits.FontName, self.Properties.Digits.FontEffect );
  	Game:WriteHudStringFixed( 
  		self.Properties.Digits.LocationX + self.Properties.Dial.LocationX,
  		self.Properties.Digits.LocationY + self.Properties.Dial.LocationY,
  		format( self.Properties.Digits.DigitFormat, value),
  		self.Properties.Digits.ColorR,
  		self.Properties.Digits.ColorG,
  		self.Properties.Digits.ColorB,
  		self.Properties.Digits.Transparency,
  		self.Properties.Digits.Width,
  		self.Properties.Digits.Height,
  		self.Properties.Digits.Scale );
  end
		

end
-------------------------------------------------------------------------------

function FuelGauge:Event_Enable()
	BroadcastEvent(self, "Enable");
	self.Properties.bEnabled = 1;
end
-------------------------------------------------------------------------------
function FuelGauge:Event_Disable()
	BroadcastEvent(self, "Disable");
	self.Properties.bEnabled = 0;
end
-------------------------------------------------------------------------------

function FuelGauge:CalcValue()
	local vehicle_realism = System:GetEntityByName( self.Properties.VehicleRealism );
	return vehicle_realism.Properties.Fuel.fTankCurrent;
end


function limit( val, vmin, vmax )
	if ( val < vmin ) then
		return vmin;
	end
	if ( val > vmax ) then
		return vmax;
	end
	return val;
end



