--Traps any key pressed. To avoid unnecessary polling (ie fps cost) enable it only
--when inside a proximity trigger or similar confined area.
--by aarbro [aarbro@hotmail.com]

Keyboard = {
	
	Properties = {
		Key = "f", --what key to wait for
		bEnabled = 0,
		bHoldKey = 0,
	},

	Editor={
		Model="Objects/EXP/Editor/editor_keyboard.cgf",
	},
	
	held = 0,

}

-------------------------------------------------------------------------------
function Keyboard:OnPropertyChange()
	self:OnReset();
end

-------------------------------------------------------------------------------
function Keyboard:OnInit()
	self:OnReset();
end

-------------------------------------------------------------------------------
function Keyboard:OnShutDown()
end

-------------------------------------------------------------------------------
function Keyboard:OnSave(stm)	
end

-------------------------------------------------------------------------------
function Keyboard:OnLoad(stm)	 
end

-------------------------------------------------------------------------------
function Keyboard:OnReset()
	self:EnableUpdate( self.Properties.bEnabled );
end

-------------------------------------------------------------------------------
function Keyboard:OnUpdate()
	if ( self.Properties.Key ~= "" ) then
		if ( self.Properties.bHoldKey == 0 ) then
  		local PressedKey = Input:GetXKeyPressedName();
  		if ( tostring(PressedKey) == self.Properties.Key ) then
  			BroadcastEvent(self, "KeyPressed");
  		end
  	else
  		local HeldKey = Input:GetXKeyDownName();
  		if ( tostring(HeldKey) == self.Properties.Key ) then
  			if ( self.held == 0 ) then
  				BroadcastEvent(self, "KeyHeld");
  				self.held = 1;
  			end
  		else
  			if ( self.held == 1 ) then
  				BroadcastEvent(self, "KeyReleased");
  				self.held = 0;
  			end
  		end
  	end
  end
end

-------------------------------------------------------------------------------
function Keyboard:Event_KeyPressed()
end
-------------------------------------------------------------------------------
function Keyboard:Event_KeyHeld()
end
-------------------------------------------------------------------------------
function Keyboard:Event_KeyReleased()
end
-------------------------------------------------------------------------------
function Keyboard:Event_Enable()
	self:EnableUpdate(1);
	BroadcastEvent(self, "Enable");
end
-------------------------------------------------------------------------------
function Keyboard:Event_Disable()
	self:EnableUpdate(0);
	BroadcastEvent(self, "Disable");
end


