--PitStop.
--by aarbro [aarbro@hotmail.com]


PitStop = {

	Editor = {
		Model="Objects/Editor/S.cgf",
	},

	Properties = {
		bEnabled = 1,
		bRefuel = 1,
		fSpeed = 1, --how long to wait before each fill/repair event
		bRepair = 1,
		vectorBBox = {x=5,y=5,z=5},
		MessageInside = "Stop vehicle to refuel/repair",
		MessageActive = "Repair and refuel in progress.",
   },
    
	car = nil,
	VR = nil,
};
-------------------------------------------------------------------------------
function PitStop:OnPropertyChange()
	self:OnReset();
end
-------------------------------------------------------------------------------

function PitStop:OnInit()
	self:OnReset();
end
-------------------------------------------------------------------------------
function PitStop:OnShutDown()
end
-------------------------------------------------------------------------------

function PitStop:OnReset()

	local Min = { x=-self.Properties.vectorBBox.x/2, y=-self.Properties.vectorBBox.y/2, z=-self.Properties.vectorBBox.z/2 };
	local Max = { x=self.Properties.vectorBBox.x/2, y=self.Properties.vectorBBox.y/2, z=self.Properties.vectorBBox.z/2 };
	self:SetBBox( Min, Max );

	if ( self.Properties.bEnabled == 1 ) then
		self:Event_Enable();
	else
		self:Event_Disable();
	end

	self.car = nil;
	self.VR = nil;

	self:RegisterState("Inside");
	self:RegisterState("Outside");
	self:GotoState( "Outside" );

end
-------------------------------------------------------------------------------
function PitStop:Event_Enable()
	self.Properties.bEnabled = 1;
	self:TrackColliders(1);
	BroadcastEvent(self, "Enable");
end
-------------------------------------------------------------------------------
function PitStop:Event_Disable()
	self.Properties.bEnabled = 0;
	self:TrackColliders(0);
	BroadcastEvent(self, "Disable");
end
-------------------------------------------------------------------------------



PitStop.Inside =
{
	-------------------------------------------------------------------------------
	OnBeginState = function( self )
		self.stopped = 0;
		self:EnableUpdate(1);
  	self:SetTimer( self.Properties.fSpeed * 1000 );
	end,
	-------------------------------------------------------------------------------
	OnEndState = function( self )
		self:EnableUpdate(0);
		self:KillTimer();
	end,
	-------------------------------------------------------------------------------
	OnUpdate = function( self )
		if ( self.car.cnt:GetVehicleVelocity() < 0.1 ) then
			self.stopped = 1;
			if ( _localplayer.theVehicle ) then
				if ( _localplayer.theVehicle == self.car ) then
					Hud.label = self.Properties.MessageActive;
				end
			end
		else
			self.stopped = 0;
			if ( _localplayer.theVehicle ) then
				if ( _localplayer.theVehicle == self.car ) then
					Hud.label = self.Properties.MessageInside;
				end
			end
		end
	end,
	-------------------------------------------------------------------------------
	OnTimer = function( self )
		if ( self.stopped == 1 ) then
			if ( self.Properties.bRefuel == 1 ) then
				self.VR:OnRefuel();
			end
			if ( self.Properties.bRepair == 1 ) then
				self.VR:OnRepair();
			end
		end
  	self:SetTimer( self.Properties.fSpeed * 1000 );
	end,
	-------------------------------------------------------------------------------
	OnLeaveArea = function( self,vehicle,areaId )
		if ( self.car == vehicle ) then
			self.car = nil;
			self:GotoState( "Outside" );
		end
	end,
	-------------------------------------------------------------------------------
}

PitStop.Outside =
{
	-------------------------------------------------------------------------------
	OnEnterArea = function( self,vehicle,areaId )
  	--Hud:AddMessage( "Entity: "..vehicle.entity_type, 5 );
  
  	if ( vehicle.entity_type ~= "vehicle" ) then --not a vehicle
  		return;
  	end
  
  	--check if the vehicle is connected to a VehicleRealism
  	self.VR = nil;
  	local ents = System:GetEntities();
  	for idx,entity in ents do
  		if ( entity.classname == "VehicleRealism" ) then
  			if ( entity.Properties.VehicleName == vehicle:GetName() ) then
  				self.VR = entity;
  			end
  		end
  	end
  	if ( self.VR == nil ) then
  		return;
  	end
  	
  	self.car = vehicle;

		self:GotoState( "Inside" );

	end,
	-------------------------------------------------------------------------------
}

