--Works like a stop-watch and is shown in the HUD.
--by aarbro [aarbro@hotmail.com]


StopWatch = {

	Editor = {
		Model="Objects/EXP/Editor/editor_stopwatch.cgf",
	},

	Properties = {
		Font = {
			Name = "default",
			Effect = "default",
			Width = 20,
			Height = 20,
			LocationX = 10,
			LocationY = 10,
			Color = {r=1,g=1,b=1,t=1},
			Scale = 0.5,
		},
		bVisible = 1,
		IntermediateTimeOn = 5,
	},

	start_time = 0,
	stop_time = 0,
	inter_time = 0,
	stopped = 1,
	show_inter = 0,
	
};


function StopWatch:OnPropertyChange()
	self:OnReset();
end

function StopWatch:OnInit()
	self:OnReset();
end

function StopWatch:OnReset()

	
	--Hud.EXP_SW_Font = self.Properties.Font;

	self.start_time = System:GetCurrTime();
	self.stop_time = self.start_time;

	self:EnableUpdate(0);
if (Hud~=nil) then
	Hud:EnableCustomHud(1); --turn on global hud updates
end
end

function StopWatch:OnShutDown()
end

function StopWatch:OnUpdateCustomHud()
	if ( self.Properties.bVisible == 1 ) then
   	local time = 0;
   	if ( self.stopped == 0 ) then
   		time = System:GetCurrTime() - self.start_time;
   	else
   		time = self.stop_time - self.start_time;
   	end
   
   	time = TimeToStr( time,"%02u:%02u:%02u" );
   	Game:SetHUDFont( self.Properties.Font.Name, self.Properties.Font.Effect );
   	Game:WriteHudStringFixed( 
   		self.Properties.Font.LocationX,
   		self.Properties.Font.LocationY,
   		time,
   		self.Properties.Font.Color.r,
   		self.Properties.Font.Color.g,
   		self.Properties.Font.Color.b,
   		self.Properties.Font.Color.t,
   		self.Properties.Font.Width,
   		self.Properties.Font.Height,
   		self.Properties.Font.Scale );
   
   	if ( self.show_inter == 1 ) then
    	Game:WriteHudStringFixed( 
    		self.Properties.Font.LocationX,
    		self.Properties.Font.LocationY + self.Properties.Font.Height,
    		TimeToStr( self.inter_time,"%02u:%02u:%02u" ),
    		self.Properties.Font.Color.r,
    		self.Properties.Font.Color.g,
    		self.Properties.Font.Color.b,
    		self.Properties.Font.Color.t,
    		self.Properties.Font.Width / 2,
    		self.Properties.Font.Height / 2,
    		self.Properties.Font.Scale );
   	end
	end
end

function StopWatch:OnSave(stm)
end

function StopWatch:OnLoad(stm)
end


-------------------------------------------------------------------------------
--EVENTS
-------------------------------------------------------------------------------

function StopWatch:Event_Reset()
	self.start_time = System:GetCurrTime();
	self.stop_time = System:GetCurrTime();
	self.inter_time = System:GetCurrTime();
end
-------------------------------------------------------------------------------
function StopWatch:Event_Start()
	if ( self.stopped == 1 ) then
		self.start_time = self.start_time + ( System:GetCurrTime() - self.stop_time );
		self.stopped = 0;
	end
end
-------------------------------------------------------------------------------
function StopWatch:Event_Stop()
	if ( self.stopped == 0 ) then
		self.stop_time = System:GetCurrTime();
		self.stopped = 1;
	end
end
-------------------------------------------------------------------------------
function StopWatch:Event_Intermediate()
	if ( self.stopped == 0 ) then
		self.inter_time = System:GetCurrTime() - self.start_time;
	else
		self.inter_time = self.stop_time - self.start_time;
	end
	self.show_inter = 1;
	self:KillTimer();
	self:SetTimer( self.Properties.IntermediateTimeOn * 1000 );
end
-------------------------------------------------------------------------------
function StopWatch:Event_Hide()
	self.Properties.bVisible = 0;
end
-------------------------------------------------------------------------------
function StopWatch:Event_Show()
	self.Properties.bVisible = 1;
end
-------------------------------------------------------------------------------
function StopWatch:OnTimer()
	self.show_inter = 0;
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

function	TimeToStr( _time, pat )
	_time = abs(_time);
	
	local m = floor ( _time / 60 );
	local s = _time - m * 60 ;
	local f = ( _time - floor ( _time ) ) * 100;
	return format (pat, m, s, f);
end
