Script:LoadScript("scripts/default/entities/pickups/basepickup.lua");

local funcPick=function (self, collider, entering)

	--self:NotifyMessage("collider.cnt.armor="..collider.cnt.armor..", collider.cnt.max_armor="..collider.cnt.max_armor);

	if (BasicPlayer.HasFullArmor(collider))then
		if (entering == 1) then
			if ((not self.lasttime) or (_time>(self.lasttime+6))) then
				-- send armor cannot catch 
				local serverSlot = Server:GetServerSlotByEntityId(collider.id);
				if (serverSlot) then
					serverSlot:SendCommand("HUD P 1 -1"); -- hud, generic pick, armor, not available
				end
			
				--self:NotifyMessage("@pickup_not_possible @armor_pickup_not_possible_trail", collider);
				self.lasttime=_time;
			end
		end
		return nil;
	end	

	local amount = BasicPlayer.AddArmor(collider, self.Properties.Amount);
	
	-- send armor catch 
	local serverSlot = Server:GetServerSlotByEntityId(collider.id);
	if (serverSlot) then	
		serverSlot:SendCommand("HUD P 1 "..self.Properties.Amount); -- hud, generic pick, armor, amount
	end
	
	--self:NotifyMessage("@YouPickedUp "..self.Properties.Amount.." @UnitsOf @Armor", collider)
	
	return 1;
		
end

local params={
	func=funcPick,
	model="Objects/pickups/armor/bodyarmor.cgf",
	default_amount=15,
	sound="sounds/player/zipper.wav",
	modelchoosable=nil,
	soundchoosable=nil,
	floating_icon="Objects/Pickups/armor/armor_icon.cga"
}

Armor=CreateCustomPickup(params);

--3up change start to EOF
Armor.PhysParam = {
	mass = 10,
	size = 0.15,
	heading = {x=0,y=0,z=-1},
	initial_velocity = 6,
	k_air_resistance = 0,
	acc_thrust = 0,
	acc_lift = 0,
	--high friction material
	surface_idx = Game:GetMaterialIDByName("mat_pickup"),
	gravity = {x=0, y=0, z=-9.8 },
	collider_to_ignore = nil,
	flags = bor(particle_constant_orientation,particle_no_path_alignment, particle_no_roll, particle_traceable),
}

function Armor:Launch( weapon, shooter, pos, angles, dir, target )

	self:SetPhysicParams( PHYSICPARAM_PARTICLE, self.PhysParam );
	self.autodelete = 1;
	self.deleteOnGameReset = 1;
	self:EnableSave(nil);
	self:GotoState("Dropped");
	-- fade away after 15 seconds
	self.Properties.FadeTime = 15;
	self.Properties.Amount = 30;
--	self:SetTimer(15000);


	local direction = g_Vectors.temp_v1;
	local dest = g_Vectors.temp_v2;
		
	CopyVector(direction,dir);
		
	dest.x = pos.x + direction.x * 1.5;
	dest.y = pos.y + direction.y * 1.5;
	dest.z = pos.z + direction.z * 1.5;
		
	local hits = System:RayWorldIntersection(pos,dest,1,ent_terrain+ent_static+ent_rigid+ent_sleeping_rigid,shooter.id);
		
	if (hits and getn(hits)>0) then
			
		local temp = hits[1].pos;
		
		dest.x = temp.x - direction.x * 0.15;
		dest.y = temp.y - direction.y * 0.15;
		dest.z = temp.z - direction.z * 0.15;
	end
	
	shooter:AwakeEnvironment();

	self:SetPos( dest );--pos );
	self:SetAngles( angles );
	self:NetPresent(1);
	
	-- the ID of the server slot who initiated the action
	-- used for statistics
	local serverSlot = Server:GetServerSlotByEntityId(shooter.id);
	
	if (serverSlot) then
		self.shooterSSID = serverSlot:GetId();
	end
	
	self.LaunchedByTeam=Game:GetEntityTeam(shooter.id);
end