
Script:LoadScript("scripts/Default/ClientStuff.lua");		-- derive functionality

	Script:LoadScript("SCRIPTS/MULTIPLAYER/MultiplayerClassDefiniton.lua");		-- global MultiplayerClassDefiniton


ClientStuff.idScoreboard=nil;										-- scoreboard entity id


---------------------------------------------------------------------------------
-- This is called whenever an entity is spawned on the client
function ClientStuff:OnSpawnEntity(entity)
	-- in multiplayer we want to have all entities updating even if we don't look at them
	entity:EnableUpdate(1);
	
	if (entity.type == "Player") then
		entity:SetViewDistRatio(255);										 	-- viewdistratio to be max (== 255)
		entity:RenderShadow( 1 );						 	-- enable rendering of player shadow
		BasicPlayer.SecondShader_TeamColoring(entity);		-- enable colorize shader (individual or team color)
		
		Hud:ResetRadar(entity);
	end
	
	if (entity.type == "Synched2DTable") then
		ClientStuff.idScoreboard=entity.id;
	end
end


-------------------------------------------------------------------------------
--
function ClientStuff:SetPlayerScore(Stream)
	local iClientID = Stream:ReadByte();
	local iPing = Stream:ReadShort();

	local SBEntityEnt = System:GetEntity(ClientStuff.idScoreboard);

	-- ClientOnly [ClientID] = Ping, update when the scoreboard packet from the server comes in
	if SBEntityEnt and SBEntityEnt.PingTable then
		SBEntityEnt.PingTable[iClientID]=iPing;
	end
end

-------------------------------------------------------------------------------
--
function ClientStuff:ShowScoreBoard(bShow)	
--	System:Log("ClientStuff:ShowScoreBoard "..tostring(bShow));  -- debug

	if (ScoreBoardManager) then
		ScoreBoardManager.SetVisible(bShow);
	end
end

-------------------------------------------------------------------------------
--
function ClientStuff:ResetScores()
end

-------------------------------------------------------------------------------
--
function ClientStuff:CalcEfficiency(score, deaths, suicides)
	if (not score or not deaths or not suicides) then
		return 0;
	end
	
--	System:Log("CalcEfficiency val "..tostring(score)..","..tostring(deaths)..","..tostring(suicides)); -- debug
--	System:Log("CalcEfficiency type "..type(score)..","..type(deaths)..","..type(suicides)); -- debug
	
	if (score <= 0) then
		return 0;
	end
	
	return floor(max(100 * score / (score + deaths + suicides) + 0.5, 0));
end


---------------------------------------------------------------------------------
-- change player objective
ClientStuff.ServerCommandTable["CPO"]=function(String,toktable)

	local tokcount=count(toktable);

	local newobjective;
		
	if tokcount>=2 then
		newobjective=toktable[2];
	end
		
	Hud.PlayerObjective = newobjective;
	
	if newobjective then
		Hud.PlayerObjectiveAnim = 1;	-- 1 is the pop up
		Hud.PlayerObjectiveAnimStart = _time;
		
		if newobjective == "POAtt" then
--			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/attacker_logo");
--			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/spark");
--			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/electric");
			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/rock");
		else
--			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/defender_logo");
--			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/bfly");
--			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/bio");
			Hud.PlayerObjectiveAnimTex = System:LoadImage("textures/hud/multiplayer/sci");
		end
	else
		Hud.PlayerObjectiveAnim=nil;
	end
end;


---------------------------------------------------------------------------------
-- respawn timer reset
ClientStuff.ServerCommandTable["RTR"]=function(String,toktable)

	if count(toktable)==2 then
		-- currently only used in the Hud
		-- set to the hud, and limboscreen
		local iRCL = tonumber(toktable[2]);
		
		if (iRCL) then
			Hud.iRespawnCycleLength = iRCL;
			Hud.iRespawnCycleStart = _time;
		end
	else
		Hud.iRespawnCycleLength = nil;
		Hud.iRespawnCycleStart = nil;
	end
end;


---------------------------------------------------------------------------------
-- your class is now <MultiplayerClassDefiniton.PlayerClasses>
-- needed to synchroize the player speed
ClientStuff.ServerCommandTable["YCN"]=function(String,toktable)
--3up synchro var start
	if count(toktable)==4 then

		local idPlayer=toktable[2];
		local classname=toktable[3];
		local bsp=tonumber(toktable[4]);
--		local classname=toktable[2];
--		local bsp=tonumber(toktable[3]);
		
		local myclass=MultiplayerClassDefiniton.PlayerClasses[classname];
		
		if not myclass then				-- e.g. DefaultMultiPlayer
			myclass=MultiplayerClassDefiniton[classname];
		end
		
		if myclass then
			local player=System:GetEntity(idPlayer);
--			local player=_localplayer;

			if player then
				player.basespeed = bsp;
			end

			if player.cnt then
				player.cnt.basespeed = bsp;
			end
			
			if player and player.cnt then

					player.cnt:SetMoveParams(myclass.move_params);
					player.move_params.jump_force=myclass.move_params.jump_force;
					player.move_params.jump_run_time=myclass.move_params.jump_run_time;
					player.move_params.jump_run_d=myclass.move_params.jump_run_d;
					player.move_params.jump_run_h=myclass.move_params.jump_run_h;
					player.move_params.jump_walk_time=myclass.move_params.jump_walk_time;
					player.move_params.jump_walk_d=myclass.move_params.jump_walk_d;
					player.move_params.jump_walk_h=myclass.move_params.jump_walk_h;
					player.move_params.speed_run=  bsp;
					player.move_params.speed_walk=  bsp * 0.77;
					player.move_params.speed_swim=  bsp * 0.72;
			
					player.move_params.speed_run_strafe= player.move_params.speed_run;
					player.move_params.speed_walk_strafe=  player.move_params.speed_walk;
					player.move_params.speed_swim_strafe=  player.move_params.speed_swim;
			
		
					player.move_params.speed_run_back=  player.move_params.speed_run;
					player.move_params.speed_walk_back=  player.move_params.speed_walk;
					player.move_params.speed_swim_back=  player.move_params.speed_swim;
					player.cnt:SetMoveParams( player.move_params );
		--3up gun weight

					local speedquat = floor(player.cnt.basespeed* 4) *0.25;
					System:Log("Your speed is now "..speedquat);



--				player.move_params = myclass.move_params;
--				player.cnt:SetMoveParams(myclass.move_params);

--				player.cnt.basespeed=myclass.basespeed;						-- is not netsynced
				player.cnt.max_health=myclass.health;						-- is not netsynced
				player.cnt.max_leghealth=myclass.leghealth;						-- is not netsynced
				player.cnt.max_armor=myclass.max_armor;					-- is not netsynced
				player.cnt.fallscale=myclass.fallscale;					-- is not netsynced
				player.cnt.killcount=myclass.killcount;
				player.cnt.gasmask=myclass.gasmask;
				if (player.cnt.vip == nil) then
					player.cnt.vip = 0;
				end
--3up synchro var end
			else
				System:Error("ServerCommandTable YCN failed - internal network error");
			end
		end
	end
end;


---------------------------------------------------------------------------------
-- receive player count
ClientStuff.ServerCommandTable["RPC"] = function(String,TokTable)

	if not Hud then
		return;
	end

--3up add classes start
--	Hud.iTeam01Count = tonumber(TokTable[2]);
--	Hud.iTeam02Count = tonumber(TokTable[2+4]);
--	Hud.iTeamSpecCount = tonumber(TokTable[2+4+4]);

	Hud.iTeam01Count = tonumber(TokTable[2]);
	Hud.iTeam02Count = tonumber(TokTable[2+9]);
	Hud.iTeamSpecCount = tonumber(TokTable[2+9+9]);

	
	Hud.Team01ClassCount = {};
	Hud.Team02ClassCount = {};

	local iClassIndex = 1;
--	for iClassIndex=1, 3 do
--		Hud.Team01ClassCount[iClassIndex] = tonumber(TokTable[2 + iClassIndex]);
--	end
--	for iClassIndex=1, 3 do
--		Hud.Team02ClassCount[iClassIndex] = tonumber(TokTable[2 + 4 + iClassIndex]);
--	end
	for iClassIndex=1, 8 do
		Hud.Team01ClassCount[iClassIndex] = tonumber(TokTable[2 + iClassIndex]);
	end
	for iClassIndex=1, 8 do
		Hud.Team02ClassCount[iClassIndex] = tonumber(TokTable[2 + 9 + iClassIndex]);
	end

--3up add classes end

	Hud.bReceivedPlayerCount = 1;
end

---------------------------------------------------------------------------------
-- 
ClientStuff.ServerCommandTable["GPC"] = function(String,TokTable)
	
	if not Hud then
		return;
	end

	Hud.iSelfWeapon1 = nil;
	Hud.iSelfWeapon2 = nil;
	Hud.iSelfWeapon3 = nil;
	Hud.iSelfWeapon4 = nil;

	Hud.szSelfTeam = tostring(TokTable[2]);
	Hud.szSelfClass = tostring(TokTable[3]);
	
	for i=1, 4 do
		if (TokTable[2 + i]) then
			Hud["iSelfWeapon"..i] = tonumber(TokTable[3 + i]);
		end
	end
	
	Hud.bReceivedSelfStat = 1;
end


---------------------------------------------------------------------------------
--
ClientStuff.ServerCommandTable["UTL"] = function(String,TokTable)
	if (Hud) then
		Hud.fTimeLimit = tonumber(TokTable[2]);
	end
end
---------------------------------------------------------------------------------
--
--ClientStuff.ServerCommandTable["UKL"] = function(String,TokTable)
--	if (Hud) then
--		Hud.fKingTimeLimit = tonumber(TokTable[2]);
--	end
--end

---------------------------------------------------------------------------------
--
function ClientStuff:GetInGameMenuVideoOn()
	return 0;
end


-------------------------------------------------------------------------------
-- callback for getting the in game menu
function ClientStuff:GetInGameMenuName()
	return "InGameNonTeam";
end

--------------------------------------------------------------------------------
-- called when a text message arrives
-- command is "say", "sayteam" or "sayone"
function ClientStuff:OnTextMessage(command, sendername, text)

	-- check if there is an ingamemenu
	local InGameMenu = ClientStuff:GetInGameMenuName();
	
	if (not InGameMenu) then
		return
	end
	
	-- check if the menu has a chatbox
	local ChatBox = UI:GetWidget("ChatBox", InGameMenu);
	
	if (not ChatBox) then
		return
	end
	
	-- at this point, nothing should go wrong...
	if (command == "sayone") then
		ChatBox:AddLine(sendername.." @MPChatPrivate "..text);
	elseif (command == "sayteam") then
		ChatBox:AddLine(sendername.." @MPChatTeam "..text);
	elseif (command == "say") then
		ChatBox:AddLine(sendername..":$1 "..text);
	end
end


---------------------------------------------------------------------------------
-- player killed player TargetEntityID,ShooterEntityID,situation=0/1/2,center=1/nil
ClientStuff.ServerCommandTable["PKP"]=function(String,toktable)
--3up kill sound start
ClientStuff.Headshot=Sound:LoadSound("Sounds/Mod/KillVoice/headshot.wav");
ClientStuff.KillvoiceSound= {
	Sound:LoadSound("Sounds/Mod/KillVoice/doublekill.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/multikill.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/rampage.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/killingspree.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/ultrakill.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/monsterkill.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/unstoppable.wav"),
	Sound:LoadSound("Sounds/Mod/KillVoice/godlike.wav")
}
--3up kill sound end
	local size=count(toktable);

-- 	System:Log(">>>> size "..size);

--3up kill material record

--	if size==5 then
--	if size==6 then
	if size==9 then
		local target=System:GetEntity(toktable[2]);
		local shooter=System:GetEntity(toktable[3]);
		local situation=toktable[4];
		local weapon=toktable[5];
--3up kill material record
		local material=toktable[6];
		local targetkc=toktable[7];
		local shooterkc=toktable[8];
		local ver=toNumberOrZero(toktable[9]);
		local myver = toNumberOrZero(getglobal("tacto_version"));

		if (myver ~= ver) then
			Hud:AddMessage("Please upgrade your Tacto version to v"..ver..", you have v"..myver, 1, 0, 0);
		end



--   	System:Log(">>>> 4 "..tostring(target));
--   	System:Log(">>>> 5 "..tostring(shooter));
--   	System:Log(">>>> 6 "..tostring(situation));

		if target and situation then
			local killmsg = {};
			
			killmsg.situation = situation;
			killmsg.weapon = weapon;
--3up kill sound start
			if (shooter == _localplayer) then
				if ((material == "head") or (material == "helmet")) then
					Sound:PlaySound(ClientStuff.Headshot);
				end

				_localplayer.cnt.killcount=_localplayer.cnt.killcount + 1;
				local killc = _localplayer.cnt.killcount;
				if(killc==2) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[1]);
				end
				if(killc==3) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[2]);
				end
				if(killc==5) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[3]);
				end
				if(killc==7) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[4]);
				end
				if(killc==10) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[5]);
				end
				if(killc==13) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[6]);
				end
				if(killc==15) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[7]);
				end
				if(killc==20) then
					Sound:PlaySound(ClientStuff.KillvoiceSound[7]);
				end

			end
--3up kill sound end		
		
			

			if situation=="1" then
--				killmsg.target = target:GetName();
				killmsg.target = target:GetName().."$9("..targetkc..")$1";

			else
				if not shooter then
					return;
				end
				
--3up killcount announce
				killmsg.shooter = shooter:GetName().."$9("..shooterkc..")$1";
				killmsg.target = target:GetName().."$9("..targetkc..")$1";
--3up kill material start
				killmsg.material = material;
--3up kill material end
			end

			-- add kill message
			Hud:AddMessage(killmsg, 7.5, 0, 1);
		end
	end
end;


function ClientStuff:OnUpdate()				
	self.vlayers:Update();

	self:UpdateScoreboard();
end
