
-- class definition for class based mods
--
-- this info is used in GameRuleClassLib.lua and in the in game menu

local MCD_Scale=1.4;
local RunSpeedMult=1.00;--patch2 : runspeed 15% faster
local staminaRunMult=0.7;--patch2 : 30% less use of stamina when run

local MCD_Scale=1.4;
local speedhackactive = tonumber(getglobal("gr_sh_enable"));
if speedhackactive==1 then
	RunSpeedMult=tonumber(getglobal("gr_sh_run"));  --1.06(1.15) GMFlash patch : runspeed 6% faster
	WalkSpeedMult=tonumber(getglobal("gr_sh_walk")); --0.94(1.00) GMFlash patch : walkspeed 6% slower		
end


if (tonumber(getglobal("gr_classdef")) == 1) then

MultiplayerClassDefiniton=
{
	PlayerClasses={			-- for class based mods
	
		Heavy=
		{
			
--			model="Objects/characters/story_characters/mertz/mertz_mp.cgf",
			model="Objects/characters/story_characters/krieger_mutant/krieger_mutant.cgf",
			isAlien = 1,
			health		= 160,
			leghealth		= 100,
			armor		= 160,
			max_armor	= 160,
			basespeed = 4.7*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.65,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"FistMelee",},
			weapon2={"AmmoTool",},
			weapon3={"P90",},
			weapon4={"M249LX",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 15.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 50.0,
				min_slide_angle = 46,
				max_climb_angle = 55,
				min_fall_angle = 70,
				max_jump_angle = 50,
			},
			
			InitialAmmo=
			{
				Pistol=24,			-- Falcon
				Shotgun=20,			-- Shotgun
				SMG=100,				-- P90
				Assault=200,		-- M4,OICW,AG36
				AmmoPack=5,
				Rocket= 3,		-- RL
				HandGrenade=2,	-- HandGrenade

				OICWGrenade=3,	-- OICW second firemod
				ProjProximityMine=1, 
				SnowBall=1,
				SnowShell=1,
				MortarShell=1,

			},
			AmmoPickup=
			{
				Pistol=24,	    -- Falcon
				Shotgun=20,			-- Shotgun
				SMG=100,				-- P90
				Assault=200,		-- M4,OICW,AG36
				AmmoPack=0,
				Rocket= 1,		-- RL
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
				ProjProximityMine=0,
				MortarShell=1,

			},
			DropAmmoPickup=
			{
				Pistol=24,			-- Falcon
				Shotgun=10,			-- Shotgun
				SMG=50,					-- P90
				Assault=100,		-- M4,OICW,AG36
				AmmoPack=1,
				Rocket= 1,		-- RL
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
				ProjProximityMine=0,
				MortarShell=1,

			},
			MaxAmmo=
			{
				Pistol=48,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				AmmoPack=6,
				Rocket= 5,		-- RL
				HandGrenade=5,	-- HandGrenade

				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
				ProjProximityMine=1,
				SnowBall=1,
				SnowShell=1,
				MortarShell=1,
				AtomicGrenade=1,

			},
		},
		

		

		Long=
		{

--			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			model="Objects/characters/workers/coretech/coretech.cgf",

--			model="objects/characters/pmodels/hero/hero_mp.cgf",
--			model="objects/characters/mercenaries/Merc_DefComm/merc_defcomm.cgf",
			isAlien = 0,
			health		=140,
			leghealth		= 100,

			armor		=30,
			max_armor	= 30,

			basespeed = 6.2*RunSpeedMult,
			carrymux = 1.0,

			fallscale = 0.75,
			--vip = 0,
			killcount = 0,
			gasmask = 1,

			weapon1={"Machete",},
			weapon2={"PP7",},
			weapon3={"Shotgun",},
			weapon4={"G3A3LX",},
			primaryWeaponSlot=4,
			grenades="PoisonGrenade",

			
			items = {
				--"PickupBinoculars",
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8,
				speed_walk=MCD_Scale*3.3,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 9.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 50.0,
				min_slide_angle = 46,
				max_climb_angle = 65,
				min_fall_angle = 70,
				max_jump_angle = 50,
			},

			InitialAmmo=
			{
				Pistol=32,			-- Falcon
				Shotgun=20,			-- Shotgun
				SMG=100,				-- P90
				Assault=63,		-- M4,OICW,AG36
				HandGrenade=4,		-- SmokeGrenade
				PoisonGrenade=3,		-- SmokeGrenade
				AG36Grenade=2,	-- AG36 second firemod
				MortarShell=1,

			},
			AmmoPickup=
			{
				Pistol=32,	    -- Falcon
				Shotgun=20,			-- Shotgun
				SMG=100,				-- P90
				Assault=63,		-- M4,OICW,AG36
				HandGrenade=1,		-- SmokeGrenade
				PoisonGrenade=0,		-- SmokeGrenade
				AG36Grenade=1,	-- AG36 second firemod
				MortarShell=1,

			},
			DropAmmoPickup=
			{
				Pistol=16,			-- Falcon
				Shotgun=10,			-- Shotgun
				SMG=50,					-- P90
				Assault=21,		-- M4,OICW,AG36
				HandGrenade=1,		-- SmokeGrenade
				PoisonGrenade=1,		-- SmokeGrenade
				AG36Grenade=1,	-- AG36 second firemod
				MortarShell=1,

			},
			MaxAmmo=
			{
				Pistol=64,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=84,		-- M4,OICW,AG36
				HandGrenade=4,		-- SmokeGrenade	
				PoisonGrenade=3,		-- SmokeGrenade
				AG36Grenade=3,	-- AG36 second firemod
				MortarShell=1,
				AtomicGrenade=1,


			},
		},

		Grunt=
		{
			model="Objects/characters/mutants/mutant_fast/mutant_fast.cgf",

			isAlien = 0,
			health		= 130,
			leghealth		= 100,
			armor		= 70,
			max_armor	= 70,
			basespeed = 5.5*RunSpeedMult,
			carrymux = 0.5,
			fallscale = 0.65,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"Falcon",},
			weapon2={"Shotgun",},
			weapon3={"P90",},
			weapon4={"OICW",},
			primaryWeaponSlot=4,
			
			grenades="ImpactGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			

			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 9.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 50.0,
				min_slide_angle = 46,
				max_climb_angle = 60,
				min_fall_angle = 70,
				max_jump_angle = 50,
			},

			InitialAmmo=
			{

				Pistol=24,			-- Falcon
				Shotgun=20,			-- Shotgun
				SMG=100,				-- P90
				Assault=120,		-- M4,OICW,AG36
				ImpactGrenade=5,	-- HandGrenade
				FlashbangGrenade=2,	
				HandGrenade=2,	-- HandGrenade

				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
				MortarShell=1,

			},
			AmmoPickup=
			{
				Pistol=24,	    -- Falcon
				Shotgun=20,			-- Shotgun
				SMG=100,				-- P90
				Assault=120,		-- M4,OICW,AG36
				ImpactGrenade=2,	-- HandGrenade
				FlashbangGrenade=2,	
				HandGrenade=2,	-- HandGrenade

				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
				MortarShell=1,

			},
			DropAmmoPickup=
			{
				Pistol=12,			-- Falcon
				Shotgun=20,			-- Shotgun
				SMG=50,					-- P90
				Assault=80,		-- M4,OICW,AG36
				ImpactGrenade=0,	-- HandGrenade
				FlashbangGrenade=2,	
				HandGrenade=2,	-- HandGrenade

				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
				MortarShell=1,

			},
			MaxAmmo=
			{
				Pistol=48,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=240,		-- M4,OICW,AG36
				ImpactGrenade=8,	-- HandGrenade
				FlashbangGrenade=4,	
				HandGrenade=5,	-- HandGrenade

				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
				MortarShell=1,
				AtomicGrenade=1,

			},

		},

		Light=
		{
--			model="Objects/characters/mercenaries/merc_scout/merc_scout_MP.cgf",
			model="Objects/characters/story_characters/valerie/valeri.cgf",

			isAlien = 0,
			health		=130,
			leghealth		= 100,

			armor		=12,
			max_armor	= 12,

			basespeed = 6.7*RunSpeedMult,
			carrymux = 2.0,

			fallscale = 0.35,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"Katana",},
			weapon2={"PP7",},
			weapon3={"MP5",},
			weapon4={"FistMelee"},
			primaryWeaponSlot=3,
			grenades="PoisonGrenade",
			
			items = {
				"PickupBinoculars",
				"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8,
				speed_walk=MCD_Scale*3.3,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},

			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 9.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 50.0,
				min_slide_angle = 70,
				max_climb_angle = 80,
				min_fall_angle = 80,
				max_jump_angle = 80,
			},


			InitialAmmo=
			{
				Pistol=32,		-- Falcon
				SMG=60,		-- Falcon
				Sniper= 20,		-- SniperRifle
				PoisonGrenade=1,		-- SmokeGrenade
				FlashbangGrenade=2,		
				HandGrenade=2,	-- HandGrenade

				AtomicGrenade=1,
				MortarShell=1,

			},
			AmmoPickup=
			{
				Pistol=32,		-- Falcon
				SMG=60,		-- Falcon
				Sniper=10,		-- SniperRifle
				PoisonGrenade=0,		-- SmokeGrenade
				FlashbangGrenade=1,		
				MortarShell=1,

			},
			DropAmmoPickup=
			{
				Pistol=32,		-- Falcon
				SMG=60,		-- Falcon
				Sniper= 10,		-- SniperRifle
				PoisonGrenade=1,		-- SmokeGrenade
				FlashbangGrenade=1,		
				HandGrenade=2,	-- HandGrenade

				AtomicGrenade=1,
				MortarShell=1,

			},
			MaxAmmo=
			{
				Pistol=64,		-- Falcon
				SMG=150,		-- Falcon
				Sniper=30,		-- SniperRifle
				PoisonGrenade=2,		-- SmokeGrenade
				FlashbangGrenade=3,		
				HandGrenade=4,	-- HandGrenade

				AtomicGrenade=1,
				MortarShell=1,

			},
		},

		Sniper=
		{
			model="Objects/characters/mercenaries/merc_sniper/merc_sniper_MP.cgf",
			isAlien = 0,
			health		=131,
			leghealth		= 100,

			armor		=20,
			max_armor	= 20,

			basespeed = 6.5*RunSpeedMult,
			carrymux = 1.0,

			fallscale = 0.35,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"SniperRifle",},
			weapon4={"MicroUzi"},
			primaryWeaponSlot=3,
			grenades="SmokeGrenade",
			
			items = {
				"PickupBinoculars",
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8,
				speed_walk=MCD_Scale*3.3,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},

			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 9.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 50.0,
				min_slide_angle = 60,
				max_climb_angle = 75,
				min_fall_angle = 80,
				max_jump_angle = 70,
			},


			InitialAmmo=
			{
				Pistol=32,		-- Falcon
				SMG=60,		-- Falcon
				Sniper= 40,		-- SniperRifle
				SmokeGrenade=3,		-- SmokeGrenade
				FlashbangGrenade=5,	
				HandGrenade=2,	-- HandGrenade
				ImpactGrenade=5,	

				--ProjProximityAlarm=3,	
				MortarShell=1,

			},
			AmmoPickup=
			{
				Pistol=32,		-- Falcon
				SMG=60,		-- Falcon
				Sniper=20,		-- SniperRifle
				SmokeGrenade=2,		-- SmokeGrenade
				--ProjProximityAlarm=1,			
				HandGrenade=2,	-- HandGrenade
				ImpactGrenade=1,
				MortarShell=1,

			},
			DropAmmoPickup=
			{
				Pistol=32,		-- Falcon
				SMG=60,		-- Falcon
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=0,		-- SmokeGrenade
				--ProjProximityAlarm=1,		
				HandGrenade=2,	-- HandGrenade
				ImpactGrenade=1,
				MortarShell=1,

			},
			MaxAmmo=
			{
				Pistol=64,		-- Falcon
				SMG=150,		-- Falcon
				Sniper=80,		-- SniperRifle
				SmokeGrenade=2,		-- SmokeGrenade
				--ProjProximityAlarm=3,			
				HandGrenade=4,	-- HandGrenade
				FlashbangGrenade=2,	
				MortarShell=1,
				AtomicGrenade=1,
				ImpactGrenade=5,
			},
		},

		
		
		Support=
		{
--			model="Objects/characters/workers/evil_worker/evil_worker_MP.cgf",
--			model="Objects/characters/workers/lab_assitant/lab_assistant_MP.cgf",
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",

			isAlien = 1,

			health		= 181,
			leghealth		= 100,

			armor		= 50,
			max_armor	= 50,

			basespeed = 6.25*RunSpeedMult,
			carrymux = 0.25,

			fallscale = 0.45,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"Falcon",},			
			weapon2={"AmmoTool",},
			weapon3={"M4",},
			weapon4={"EngineerTool", },	-- Wrench building and repairing / scouttool for blowing things up
			primaryWeaponSlot=3,
			grenades="StickyExplosive",

			items = {
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8,
				speed_walk=MCD_Scale*3.2,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.4,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.5,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 3,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},

			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 9.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 50.0,
				min_slide_angle = 46,
				max_climb_angle = 55,
				min_fall_angle = 70,
				max_jump_angle = 50,
			},


			InitialAmmo=
			{
				Pistol=32,			-- Falcon
				Assault=150,		-- Shotgun
				HealthPack=3,		-- Healthpacks
				SMG=125,
				AmmoPack=5,
				StickyExplosive=5,-- ScoutTool		
				ProjProximityMine=3,
				HandGrenade=2,	-- HandGrenade

				MortarShell=1,

			},
			AmmoPickup=
			{
				Pistol=32,		-- Falcon
				Assault=50,		-- Shotgun
				HealthPack=2,		-- Healthpacks
				SMG=75,
				AmmoPack=0,
				StickyExplosive=3,-- ScoutTool		
				ProjProximityMine=0,
				HandGrenade=4,	-- HandGrenade

				MortarShell=1,

			},
			DropAmmoPickup=
			{
				Pistol=32,		-- Falcon
				Assault=50,		-- Shotgun
				HealthPack=2,		-- Healthpacks
				SMG=60,
				AmmoPack=1,
				StickyExplosive=2,-- ScoutTool	
				ProjProximityMine=0,	
				HandGrenade=2,	-- HandGrenade

				MortarShell=1,

			},
			MaxAmmo=
			{
				Pistol=64,		-- Falcon
				Assault=250,		-- Shotgun
				HealthPack=6,		-- MedicTool
				SMG=200,
				AmmoPack=5,
				StickyExplosive=5,-- ScoutTool	
				ProjProximityMine=3,	
				HandGrenade=4,	-- HandGrenade

				MortarShell=1,
				AtomicGrenade=1,

			},
		},
		MutMortar=
		{
--			model="Objects/characters/pmodels/hero/hero_mp.cgf",
--			model="Objects/characters/story_characters/krieger_mutant/krieger_mutant.cgf",
			model="Objects/characters/mutants/mutant_big/mutant_big_noweapon.cgf",

			isAlien = 0,
			health		= 130,
			leghealth		= 100,

			armor		= 150,
			max_armor	= 150,

			basespeed = 5.0*RunSpeedMult,
			carrymux = 0.5,

			fallscale = 0.45,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"FistMelee",},			
			weapon2={"MP5",},
			weapon3={"Mortar",},
			weapon4={"RL", },	-- Wrench building and repairing / scouttool for blowing things up
			primaryWeaponSlot=3,
			grenades="FlashbangGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8,
				speed_walk=MCD_Scale*3.2,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.4,
				speed_prone=MCD_Scale*0.6,
				jump_force=10.3,
				jump_run_h=20.2,
				jump_run_d=70,
				jump_run_time=100,
				jump_walk_h=20,
				jump_walk_d=30,
				jump_walk_time=100,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},


			DynProp = {
				air_control = 0.7, 
				gravity = 9.81,--18.81,
				jump_gravity = 9.0,
				swimming_gravity = -1.0,
				inertia = 10.0,
				swimming_inertia = 1.0,
				nod_speed = 1.0,
				min_slide_angle = 46,
				max_climb_angle = 55,
				min_fall_angle = 70,
				max_jump_angle = 50,
			},

			InitialAmmo=
			{
				Pistol=34,			-- Falcon
				Assault=150,		-- Shotgun
				HealthPack=3,		-- Healthpacks
				SMG=125,
				Rocket=4,
				SmokeGrenade=1,		-- SmokeGrenade	
				FlashbangGrenade=2,-- ScoutTool	
				HandGrenade=2,	-- HandGrenade

				ArmorPack=3,	
				MortarShell=4,
				--ProjProximityAlarm=3,	
			},
			AmmoPickup=
			{
				Pistol=32,		-- Falcon
				Assault=50,		-- Shotgun
				HealthPack=2,		-- Healthpacks
				SMG=75,
				Rocket=1,
				SmokeGrenade=1,		-- SmokeGrenade	
				FlashbangGrenade=1,-- ScoutTool	
				HandGrenade=2,	-- HandGrenade

				ArmorPack=1,	
				MortarShell=3,
				--ProjProximityAlarm=1,	
			},
			DropAmmoPickup=
			{
				Pistol=32,		-- Falcon
				Assault=50,		-- Shotgun
				HealthPack=2,		-- Healthpacks
				SMG=60,
				Rocket=1,
				SmokeGrenade=0,		-- SmokeGrenade	
				FlashbangGrenade=1,-- ScoutTool	
				HandGrenade=2,	-- HandGrenade

				ArmorPack=1,	
				MortarShell=3,
				--ProjProximityAlarm=1,	
			},
			MaxAmmo=
			{
				Pistol=64,		-- Falcon
				Assault=250,		-- Shotgun
				HealthPack=6,		-- MedicTool
				SMG=200,
				Rocket=5,
				SmokeGrenade=2,		-- SmokeGrenade	
				FlashbangGrenade=3,-- ScoutTool	
				HandGrenade=4,	-- HandGrenade

				ArmorPack=4,	
				MortarShell=6,
				--ProjProximityAlarm=3,	
				AtomicGrenade=1,

			},
		},
	
		MutantMan=
		{
--		model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
		model="Objects/characters/mutants/mutant_aberration/mutant_aberration.cgf",
			isAlien = 1,

			health		= 100, --150
			leghealth	= 100,
			armor		= 60, --100
			max_armor	= 60,
			basespeed = 8.5*RunSpeedMult,
			carrymux = 3,
			fallscale = 0.15,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

			weapon1={"FistMelee",},
			weapon2={"MedicTool",},
			weapon3={"ArmorTool",},
			weapon4={"AmmoTool",},
			primaryWeaponSlot=1,
			
			grenades="HandGrenade",

			items = {
				"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*4.0,
				speed_walk=MCD_Scale*3.3, --3.0
				speed_swim=MCD_Scale*3.1, --2.8
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=0.3, --4.3
				jump_run_h=20.2,
				jump_run_d=70,
				jump_run_time=10,
				jump_walk_h=20,
				jump_walk_d=30,
				jump_walk_time=10,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			DynProp = {
				air_control = 0.435, --0.9
				gravity = 3.81,--18.81,
				jump_gravity = 3.0, --3
				swimming_gravity = -1.0,
				inertia = 9.0,
				swimming_inertia = 1.0,
				nod_speed = 150.0,
				min_slide_angle = 80,
				max_climb_angle = 89,
				min_fall_angle = 85,
				max_jump_angle = 89,
			},

			StaminaTable = {
				sprintScale	= 2.0,
				sprintSwimScale = 2.4, --1.4
				decoyRun	= 60*staminaRunMult,
				decoyJump	= 5, --10
				restoreRun	= 8, --3
				restoreWalk	= 11, --8
				restoreIdle	= 23, --10
		
				breathDecoyUnderwater	= 1,  --3
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},

		

			
			InitialAmmo=
			{
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				MortarShell=1,
				HandGrenade=2,	-- HandGrenade

			},
			AmmoPickup=
			{
				AmmoPack=1,
				HealthPack=1,		-- MedicTool
				ArmorPack=1,
				MortarShell=1,
				HandGrenade=2,	-- HandGrenade


			},
			DropAmmoPickup=
			{
				AmmoPack=1,
				HealthPack=1,		-- MedicTool
				ArmorPack=1,
				MortarShell=1,
				HandGrenade=2,	-- HandGrenade


			},
			MaxAmmo=
			{
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,
				MortarShell=1,
				HandGrenade=4,	-- HandGrenade
				AtomicGrenade=1,


			},
		},

	},
	-----------------------------------------------------------------

	DefaultMultiPlayer=				-- team or non team mods
	{
		health		= 130, 	
		leghealth		= 100,
		
		armor		= 0,
		max_armor	= 100,
			fallscale = 1,
			--vip = 0,
			killcount = 0,
			gasmask = 0,

		basespeed = 6.0*RunSpeedMult,
		carrymux = 0.5,

		move_params = {
			speed_run=MCD_Scale*4.2,
			speed_walk=MCD_Scale*3.5,
			speed_swim=MCD_Scale*2.8,
			speed_crouch=MCD_Scale*1.6,
                        speed_prone=MCD_Scale*0.6,
			jump_force=MCD_Scale*6.3,
				jump_run_h=1.1,
				jump_run_d=3.5,
				jump_run_time=0.4,
				jump_walk_h=1,
				jump_walk_d=1.5,
				jump_walk_time=0.2,
			lean_angle=14.0,
			bob_pitch=0.015,
			bob_roll=0.035,
			bob_lenght=5.5*MCD_Scale,
			bob_weapon=0.005/MCD_Scale,
		},
		
		StaminaTable = {
			sprintScale	= 1.4,
			sprintSwimScale = 1.4,
			decoyRun	= 30*staminaRunMult,
			decoyJump	= 10,
			restoreRun	= 1.5,
			restoreWalk	= 8,
			restoreIdle	= 10,
	
			breathDecoyUnderwater	= 4,
			breathDecoyAim		= 10,
			breathRestore		= 80,
		},
		DynProp = {
			air_control = 0.7, 
			gravity = 9.81,--18.81,
			jump_gravity = 9.0,
			swimming_gravity = -1.0,
			inertia = 10.0,
			swimming_inertia = 1.0,
			nod_speed = 50.0,
			min_slide_angle = 46,
			max_climb_angle = 55,
			min_fall_angle = 70,
			max_jump_angle = 50,
		},

	},
};













end

if (tonumber(getglobal("gr_classdef")) == 2) then







MultiplayerClassDefiniton=
{

	PlayerClasses={			-- for class based mods
	
		MutantMan=
		{
			model="Objects/characters/story_characters/harlan/harlan.cgf",
			health		=130,
			armor		=50,
			max_armor	= 50,


			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,


			weapon1={"FistMelee",},
			weapon2={"AmmoTool",},
			weapon3={"P90",},
			weapon4={"M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=1,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=1,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		

		Light=
		{
			model="Objects/characters/workers/coretechdark/coretechdark.cgf",
			health		=130,
			armor		=50,
			max_armor	= 50,


			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,


			weapon1={"Falcon",},
			weapon2={"ArmorTool",},
			weapon3={"MedicTool",},
			weapon4={"SPAS",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=6,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		

		MutMortar=
		{
			model="Objects/characters/mercenaries/Merc_Rear/merc_rear_MP.cgf",
			health		= 131,
			armor		= 50,
			max_armor	= 50,

			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,


			weapon1={"FistMelee",},			
			weapon2={"PP7",},
			weapon3={"MP5A4",},
			weapon4={"FAMAS",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=6,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		
		Heavy=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 131,
			armor		= 50,
			max_armor	= 50,

			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,

			weapon1={"FistMelee",},
			weapon2={"AmmoTool",},
			weapon3={"P90",},
			weapon4={"G3A3",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=0,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=0,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=6,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		

		Long=
		{
			model="Objects/characters/story_characters/mertz/mertz_mp.cgf",
			health		= 131,
			armor		= 50,
			max_armor	= 50,

			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,

			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90",},
			weapon4={"Mortar",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=6,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		
		Grunt=
		{
			model="Objects/characters/mercenaries/merc_scout/merc_scout_MP.cgf",
			health		=131,
			armor		=50,
			max_armor	= 50,


			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,


			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"MicroUzi",},
			weapon4={"M16A2",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		

		Sniper=
		{
			model="Objects/characters/mercenaries/merc_sniper/merc_sniper_MP.cgf",
			health		=131,
			armor		=50,
			max_armor	= 50,


			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,

			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"MicroUzi",},
			weapon4={"PSG"},
			primaryWeaponSlot=4,
			grenades="SmokeGrenade",
			
			items = {
				"PickupBinoculars",
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8*RunSpeedMult,
				speed_walk=MCD_Scale*3.3,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 33,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 22,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 22,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 55,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
			},
		},
		
		Support=
		{
			model="Objects/characters/workers/lab_assitant/lab_assistant_MP.cgf",
			health		=131,
			armor		=50,
			max_armor	= 50,

			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.55,
			killcount = 0,
			gasmask = 0,

			weapon1={"Falcon",},			
			weapon2={"AmmoTool",},
			weapon3={"EngineerTool",},
			weapon4={"MP5A4",},		-- Wrench building and repairing / scouttool for blowing things up
			primaryWeaponSlot=4,
			grenades="SmokeGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8*RunSpeedMult,
				speed_walk=MCD_Scale*3.2,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.4,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,
				StickyExplosive=3,-- ScoutTool		
			},
			AmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=0,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,	
				StickyExplosive=3,-- ScoutTool		
			},
			DropAmmoPickup=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=0,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=1,
				StickyExplosive=0,-- ScoutTool		
			},
			MaxAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				OICWGrenade=3,	-- OICW second firemod
				AmmoPack=5,
				HealthPack=6,		-- MedicTool
				ArmorPack=4,	
				Rocket= 1,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
				MortarShell=4,	
				StickyExplosive=3,-- ScoutTool		
			},
		},
	},
	-----------------------------------------------------------------

	DefaultMultiPlayer=				-- team or non team mods
	{
		health		= 130, 			
		armor		= 0,
		max_armor	= 100,

			isAlien = 0,
			basespeed = 5*RunSpeedMult,
			carrymux = 0.25,
			fallscale = 0.65,
			killcount = 0,
			gasmask = 0,

		move_params = {
			speed_run=MCD_Scale*4.2*RunSpeedMult,
			speed_walk=MCD_Scale*3.5,
			speed_swim=MCD_Scale*2.8,
			speed_crouch=MCD_Scale*1.6,
                        speed_prone=MCD_Scale*0.6,
			jump_force=MCD_Scale*66.3,
			lean_angle=14.0,
			bob_pitch=0.015,
			bob_roll=0.035,
			bob_lenght=5.5*MCD_Scale,
			bob_weapon=0.005/MCD_Scale,
		},
		
		StaminaTable = {
			sprintScale	= 1.4,
			sprintSwimScale = 1.4,
			decoyRun	= 30*staminaRunMult,
			decoyJump	= 10,
			restoreRun	= 1.5,
			restoreWalk	= 8,
			restoreIdle	= 10,
	
			breathDecoyUnderwater	= 4,
			breathDecoyAim		= 10,
			breathRestore		= 80,
		},
	},
};
end
if (tonumber(getglobal("gr_classdef")) == 3) then

MultiplayerClassDefiniton=
{
	PlayerClasses={			-- for class based mods
	

		MutMortar=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 130,
			armor		= 50,
			max_armor	= 50,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90","Shotgun",},
			weapon4={"AG36","OICW","M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
			AmmoPickup=
			{
				Pistol=45,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=100,				-- P90
				Assault=125,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
			},
			DropAmmoPickup=
			{
				Pistol=25,			-- Falcon
				Shotgun=15,			-- Shotgun
				SMG=75,					-- P90
				Assault=100,		-- M4,OICW,AG36
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
			},
			MaxAmmo=
			{
				Pistol=90,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
		},

		Heavy=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 130,
			armor		= 50,
			max_armor	= 50,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90","Shotgun",},
			weapon4={"AG36","OICW","M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
			AmmoPickup=
			{
				Pistol=45,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=100,				-- P90
				Assault=125,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
			},
			DropAmmoPickup=
			{
				Pistol=25,			-- Falcon
				Shotgun=15,			-- Shotgun
				SMG=75,					-- P90
				Assault=100,		-- M4,OICW,AG36
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
			},
			MaxAmmo=
			{
				Pistol=90,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
		},

		Light=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 130,
			armor		= 50,
			max_armor	= 50,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90","Shotgun",},
			weapon4={"AG36","OICW","M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
			AmmoPickup=
			{
				Pistol=45,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=100,				-- P90
				Assault=125,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
			},
			DropAmmoPickup=
			{
				Pistol=25,			-- Falcon
				Shotgun=15,			-- Shotgun
				SMG=75,					-- P90
				Assault=100,		-- M4,OICW,AG36
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
			},
			MaxAmmo=
			{
				Pistol=90,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
		},

		Long=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 130,
			armor		= 50,
			max_armor	= 50,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90","Shotgun",},
			weapon4={"AG36","OICW","M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
			AmmoPickup=
			{
				Pistol=45,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=100,				-- P90
				Assault=125,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
			},
			DropAmmoPickup=
			{
				Pistol=25,			-- Falcon
				Shotgun=15,			-- Shotgun
				SMG=75,					-- P90
				Assault=100,		-- M4,OICW,AG36
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
			},
			MaxAmmo=
			{
				Pistol=90,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
		},

		MutantMan=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 130,
			armor		= 50,
			max_armor	= 50,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90","Shotgun",},
			weapon4={"AG36","OICW","M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
			AmmoPickup=
			{
				Pistol=45,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=100,				-- P90
				Assault=125,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
			},
			DropAmmoPickup=
			{
				Pistol=25,			-- Falcon
				Shotgun=15,			-- Shotgun
				SMG=75,					-- P90
				Assault=100,		-- M4,OICW,AG36
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
			},
			MaxAmmo=
			{
				Pistol=90,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
		},


		Grunt=
		{
			model="Objects/characters/mercenaries/Merc_cover/merc_cover_MP.cgf",
			health		= 130,
			armor		= 50,
			max_armor	= 50,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"P90","Shotgun",},
			weapon4={"AG36","OICW","M249",},
			primaryWeaponSlot=4,
			
			grenades="HandGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
	
			move_params = {
				speed_run=MCD_Scale*3.5*RunSpeedMult,
				speed_walk=MCD_Scale*3.0,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=3.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
			
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Shotgun=30,			-- Shotgun
				SMG=150,				-- P90
				Assault=200,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
			AmmoPickup=
			{
				Pistol=45,	    -- Falcon
				Shotgun=30,			-- Shotgun
				SMG=100,				-- P90
				Assault=125,		-- M4,OICW,AG36
				HandGrenade=2,	-- HandGrenade
				AG36Grenade=2,	-- AG36 second firemod
				OICWGrenade=2,	-- OICW second firemod
			},
			DropAmmoPickup=
			{
				Pistol=25,			-- Falcon
				Shotgun=15,			-- Shotgun
				SMG=75,					-- P90
				Assault=100,		-- M4,OICW,AG36
				HandGrenade=0,	-- HandGrenade
				AG36Grenade=1,	-- AG36 second firemod
				OICWGrenade=1,	-- OICW second firemod
			},
			MaxAmmo=
			{
				Pistol=90,	    -- Falcon
				Shotgun=50,			-- Shotgun
				SMG=200,				-- P90
				Assault=250,		-- M4,OICW,AG36
				HandGrenade=5,	-- HandGrenade
				AG36Grenade=3,	-- AG36 second firemod
				OICWGrenade=3,	-- OICW second firemod
			},
		},
		
		Sniper=
		{
			model="Objects/characters/mercenaries/merc_sniper/merc_sniper_MP.cgf",
			health		=130,
			armor		=12,
			max_armor	= 12,
			weapon1={"Machete",},
			weapon2={"Falcon",},
			weapon3={"SniperRifle","RL",},
			weapon4={},
			primaryWeaponSlot=3,
			grenades="SmokeGrenade",
			
			items = {
				"PickupBinoculars",
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8*RunSpeedMult,
				speed_walk=MCD_Scale*3.3,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.6,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			InitialAmmo=
			{
				Pistol=90,		-- Falcon
				Rocket= 10,		-- RL
				Sniper= 20,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
			},
			AmmoPickup=
			{
				Pistol=45,		-- Falcon
				Rocket= 5,		-- RL
				Sniper=10,		-- SniperRifle
				SmokeGrenade=1,		-- SmokeGrenade
			},
			DropAmmoPickup=
			{
				Pistol=45,		-- Falcon
				Rocket= 5,		-- RL
				Sniper= 10,		-- SniperRifle
				SmokeGrenade=0,		-- SmokeGrenade
			},
			MaxAmmo=
			{
				Pistol=90,		-- Falcon
				Rocket=10,		-- RL
				Sniper=30,		-- SniperRifle
				SmokeGrenade=2,		-- SmokeGrenade
			},
		},
		
		Support=
		{
			model="Objects/characters/workers/evil_worker/evil_worker_MP.cgf",
			health		= 225,
			armor		= 25,
			max_armor	= 25,
			weapon1={"Falcon",},			
			weapon2={"MedicTool", "M4",},
			weapon3={"ScoutTool",},
			weapon4={"EngineerTool", },	-- Wrench building and repairing / scouttool for blowing things up
			primaryWeaponSlot=1,
			grenades="SmokeGrenade",

			items = {
				--"PickupHeatVisionGoggles",
			},
			
			move_params = {
				speed_run=MCD_Scale*3.8*RunSpeedMult,
				speed_walk=MCD_Scale*3.2,
				speed_swim=MCD_Scale*2.8,
				speed_crouch=MCD_Scale*1.4,
				speed_prone=MCD_Scale*0.6,
				jump_force=4.3,
				lean_angle=14.0,
				bob_pitch=0.015,
				bob_roll=0.035,
				bob_lenght=5.5*MCD_Scale,
				bob_weapon=0.005/MCD_Scale,
			},
	
			StaminaTable = {
				sprintScale	= 1.4,
				sprintSwimScale = 1.4,
				decoyRun	= 30*staminaRunMult,
				decoyJump	= 10,
				restoreRun	= 1.5,
				restoreWalk	= 8,
				restoreIdle	= 10,
		
				breathDecoyUnderwater	= 3,
				breathDecoyAim		= 10,
				breathRestore		= 80,
			},
			InitialAmmo=
			{
				Pistol=90,			-- Falcon
				Assault=200,		-- Shotgun
				HealthPack=3,		-- Healthpacks
				SMG=175,
				SmokeGrenade=1,		-- SmokeGrenade	
				StickyExplosive=3,-- ScoutTool		
			},
			AmmoPickup=
			{
				Pistol=45,		-- Falcon
				Assault=50,		-- Shotgun
				HealthPack=2,		-- Healthpacks
				SMG=100,
				SmokeGrenade=1,		-- SmokeGrenade	
				StickyExplosive=3,-- ScoutTool		
			},
			DropAmmoPickup=
			{
				Pistol=30,		-- Falcon
				Assault=50,		-- Shotgun
				HealthPack=2,		-- Healthpacks
				SMG=60,
				SmokeGrenade=0,		-- SmokeGrenade	
				StickyExplosive=0,-- ScoutTool		
			},
			MaxAmmo=
			{
				Pistol=90,		-- Falcon
				Assault=250,		-- Shotgun
				HealthPack=6,		-- MedicTool
				SMG=250,
				SmokeGrenade=2,		-- SmokeGrenade	
				StickyExplosive=3,-- ScoutTool		
			},
		},
	},
	-----------------------------------------------------------------

	DefaultMultiPlayer=				-- team or non team mods
	{
		health		= 130, 			
		armor		= 0,
		max_armor	= 100,

		move_params = {
			speed_run=MCD_Scale*4.2*RunSpeedMult,
			speed_walk=MCD_Scale*3.5,
			speed_swim=MCD_Scale*2.8,
			speed_crouch=MCD_Scale*1.6,
                        speed_prone=MCD_Scale*0.6,
			jump_force=MCD_Scale*66.3,
			lean_angle=14.0,
			bob_pitch=0.015,
			bob_roll=0.035,
			bob_lenght=5.5*MCD_Scale,
			bob_weapon=0.005/MCD_Scale,
		},
		
		StaminaTable = {
			sprintScale	= 1.4,
			sprintSwimScale = 1.4,
			decoyRun	= 30*staminaRunMult,
			decoyJump	= 10,
			restoreRun	= 1.5,
			restoreWalk	= 8,
			restoreIdle	= 10,
	
			breathDecoyUnderwater	= 4,
			breathDecoyAim		= 10,
			breathRestore		= 80,
		},
	},
};
end
